class App {
 
 
 select = e => document.querySelector(e);
 selectAll = e => document.querySelectorAll(e); 
 mainTl = new TimelineMax({paused:true});
 search = this.select('#search');
 magnifier = this.select('#magnifier');
 searchGroup = this.select('#searchGroup');
 close = this.select('.close');
 wholeSearch = this.select('.wholeSearch');
 hit = this.select('#hit');
 fieldWidth = 301;
 searchWidth = 210;
 seX = -260;
 fieldX = -260;
 growInc = 15;
 magStartX = -200;
 magEndX = -258;
 searchGroupX = 100; 
 wholeSearchX = 400;
 searchX = 74;
 minChars = 15;
 maxChars = 26;
 charCount = 1; 

 
  constructor(){
       
   document.body.classList.add('close-search');
   
  TweenMax.globalTimeScale(2);
   const tl = new TimelineMax();

   
   TweenMax.set(this.search, {
    x:this.searchX,
    y:12,
    xPercent:-50,
    yPercent:0
   })   
   TweenMax.set(this.close, {
    x:0,
    y:0 
   })
   //this.mainTl.add(tl);
    
   this.mainTl.to('#se', 1, {
    x:this.seX,
    ease:Expo.easeInOut
   })
   .to('#field', 1, {
    attr:{
     width:this.fieldWidth
    },
    x:this.fieldX,
    ease:Expo.easeInOut
   },'-=1')
   .to(this.wholeSearch, 1, {
    attr:{
      x:this.wholeSearchX
    },
    ease:Expo.easeInOut
   },'-=1')
   .fromTo(this.magnifier, 1, {
    autoAlpha:0,
    scale:0,
    //rotation:-90,
    transformOrigin:'0% 45%',
    x:this.magStartX
   },{
    autoAlpha:0.38,
    rotation:0,
    scale:1,
    transformOrigin:'0% 45%',
    x:this.magEndX,
    ease:Expo.easeInOut
   },'-=0.95')
   .fromTo(this.close, 1, {
    autoAlpha:0,
    scale:0,
    //rotation:-90,
    transformOrigin:'50% 50%',
    svgOrigin:'511 300',
    x:0
   },{
    autoAlpha:0.5,
    rotation:0,
    scale:1,
    transformOrigin:'50% 50%',
    svgOrigin:'511 300',
    x:0,
    ease:Expo.easeInOut
   },'-=1')
   .from(this.search, 0.5, {
    autoAlpha:0
   },'-=0.5')


  
   .addPause('+=0', function(){this.search.focus();}, [], this )
   
   
   this.close.addEventListener('click', this.clearField);
   this.wholeSearch.addEventListener('click', this.clickSearch);
   this.wholeSearch.addEventListener('touchstart', this.clickSearch);
   document.body.addEventListener('click', this.closeSearch);

   this.search.addEventListener('keydown', this.onKeyDown);
  }
 clearField = e => {
  
  if(this.search.value == ""){
   this.doOutro();
  }  else {
  //this.search.value = "";
  TweenMax.to(this.search, 0.2, {
   value:'',
   onComplete:this.resetFieldWidth,
   ease:Linear.easeNone
  })
  this.search.focus();
   
  } 
 }
 
 doOutro = e => {
  this.hit.classList.remove('disabled');
  this.searchGroup.classList.remove('disabled');    
  var outroTl = new TimelineMax({onComplete: () => {
    this.search.value = "";
   
   this.mainTl.pause(0);
   }}).timeScale(1);
   outroTl.to([this.magnifier, this.close, this.search], 0.2, {
     autoAlpha:0,
     ease:Sine.easeIn
    })
    .to('#se', 1, {
       x:0,
       ease:Expo.easeInOut
     },'-=0.2')
    .to('#field', 1, {
     attr:{
      width:41
     },
     x:0,
     ease:Expo.easeInOut
    },'-=1')
    .to(this.search, 1, {
     width:this.searchWidth,
     x:this.searchX,
     ease:Expo.easeInOut
    },'-=1')
     .to(this.wholeSearch, 1, {
     attr:{
      x:300
     },
     ease:Expo.easeInOut
    },'-=1')
 }
 

 onKeyDown = e => {

    this.charCount = this.search.value.length+1;

    if(this.charCount >= this.minChars){
     let diffChars = this.charCount - this.minChars;
     TweenMax.to('#se',0.2, {
      x:this.seX - (diffChars * this.growInc)
     })     
     TweenMax.to('#field',0.2, {
      attr:{
       width:this.fieldWidth + (diffChars * this.growInc),
      },
       x:this.fieldX - (diffChars * this.growInc)
     })
     
     TweenMax.to(this.search, 0.2, {
      x:this.searchX + (diffChars * (this.growInc/2)),
      width:this.searchWidth + (diffChars * this.growInc)
     })

     TweenMax.to(this.magnifier, 0.2, {
      x:this.magEndX - (diffChars * this.growInc)
     })
     TweenMax.to(this.wholeSearch, 0.2, {
      attr:{
        x:this.wholeSearchX + (diffChars * (this.growInc/2))       
      }
     })
     TweenMax.to(this.close, 0.2, {
      x:(diffChars * (this.growInc/2)) 
     })
    }
     if(this.search.value != ""){
      //this.hit.classList.add('disabled');
      //this.searchGroup.classList.add('disabled');
     }
 }
 
 resetFieldWidth = () => {
   let tl = new TimelineMax();
  
     tl.to('#se',1, {
      x:this.seX ,
      ease:Expo.easeInOut
     })     
     .to('#field',1, {
      attr:{
       width:this.fieldWidth 
      },
       x:this.fieldX ,
      ease:Expo.easeInOut
     },0)
     
     .to(this.search, 1, {
      x:this.searchX,
      width:this.searchWidth ,
      ease:Expo.easeInOut
     },0)

     .to(this.magnifier, 1, {
      x:this.magEndX ,
      ease:Expo.easeInOut
     },0)
     .to(this.wholeSearch, 1, {
      attr:{
        x:this.wholeSearchX        
      },
      ease:Expo.easeInOut
     },0)
     .to(this.close, 1, {
      x:0,
      ease:Expo.easeInOut
     },0)
    
  
 }
 
 clickSearch= e =>{
  //console.log("clickSearch");

  if(this.mainTl.time() == 0){
   
   this.mainTl.play(0);
   
  } else {
   
   this.doOutro();

  }
 }
 
 closeSearch = e => {

  if(this.mainTl.time() > 0){
   if(e.target.classList.contains('close-search')){
    this.doOutro();
   }
  }
 }
 
}


TweenMax.set('svg', {
  visibility: 'visible'
})

var app = new App();

